package com.examples;

import java.sql.SQLException;
import java.sql.DriverManager;
import java.util.Properties;

import oracle.jdbc.OracleConnection;

public class OracleDAO extends DAOBase
{
	private  final   String     DRIVER_oracle    = "oracle.jdbc.OracleDriver"  ;
	private  final   String     URL_oracle       = "jdbc:oracle:thin:@%s:%d:%s";

	private  final   String     URL_host         = "localhost";
	private  final   int        PORT_oracle      = 1521;
		
	private  final   String     SCHEMA_oracle    = "...";
	private  final   String     login            = "...";
	private  final   String     password         = "...";
	
	private  final   String     TABLE_blobs      = "CREATE TABLE blobs( "       +
                                                      "id    INT PRIMARY KEY, " +
                                                      "data  BLOB NULL)" ;
	private  final   String     TABLE_files      = "CREATE TABLE files( "       +
                                                      "id    INT PRIMARY KEY, " +
                                                      "data  CLOB NULL)" ;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	public OracleDAO()
	{
		createConnection();
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	@Override
	public void createConnection()
	{
		try {
			// Регистрация драйвера
			Class.forName(DRIVER_oracle).newInstance();
			// Определение свойств подключения Connection
			Properties properties = new Properties();
			properties.setProperty("password"         , password);
			properties.setProperty("user"             , login   );
			properties.setProperty("useUnicode"       , "true"  );
			properties.setProperty("characterEncoding", "utf8"  );
			
			String url = String.format(URL_oracle, URL_host, PORT_oracle, SCHEMA_oracle);
			connection = (OracleConnection) DriverManager.getConnection(url, properties);
			connection.setAutoCommit(false);
		} catch (InstantiationException e) {
			System.err.println(e.getMessage());
		} catch (IllegalAccessException e) {
			System.err.println(e.getMessage());
		} catch (ClassNotFoundException e) {
			System.err.println(e.getMessage());
		} catch (SQLException           e) {
			System.err.println(e.getMessage());
			connection = null;
		}
	};
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	@Override
	public boolean createTable(final String table)
	{
		if (table.equalsIgnoreCase("blobs"))
			return execSQL (TABLE_blobs);
		else if (table.equalsIgnoreCase("files"))
			return execSQL (TABLE_files);
		else
			return false;
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
}
